package com.sun.corba.se.spi.presentation.rmi;

import org.omg.CORBA.portable.ApplicationException;
import org.omg.CORBA_2_3.portable.OutputStream;
import org.omg.CORBA_2_3.portable.InputStream;
import java.rmi.RemoteException;
import com.sun.corba.se.spi.orb.ORB;
import java.lang.reflect.Method;

public interface DynamicMethodMarshaller
{
    public abstract Method getMethod();
    
    public abstract Object[] copyArguments(Object[] p0, ORB p1) throws RemoteException;
    
    public abstract Object[] readArguments(InputStream p0);
    
    public abstract void writeArguments(OutputStream p0, Object[] p1);
    
    public abstract Object copyResult(Object p0, ORB p1) throws RemoteException;
    
    public abstract Object readResult(InputStream p0);
    
    public abstract void writeResult(OutputStream p0, Object p1);
    
    public abstract boolean isDeclaredException(Throwable p0);
    
    public abstract void writeException(OutputStream p0, Exception p1);
    
    public abstract Exception readException(ApplicationException p0);
}
